function Algorithm9_8_ProbabilisticRSAFactoring(n,d,e)
% Algorithm9_8_ProbabilisticRSAFactoring(n,d,e)



%first we determine the largest power s of 2 that divides ed - 1:
ed = e*d;
s = 0;
while floor((ed-1)/2^(s+1)) == (ed-1)/2^(s+1)
    s = s + 1;
end
f = (ed-1)/2^s;
fprintf('f = %d, s = %d, satisfy ed - 1 = 2^s*f.\r', f,s)

a = ceil((n-1)*rand)
D = gcd(a,n);
fprintf('gcd(a,n) = %d.', D)
t = s - 1;
fprintf('Initialize t = s - 1 = %d.\r', t)
while ismember(D,[1 n]) & t>=0
    fprintf('Since D = %d is 1 or n, and t = %d > 0 we do the following:\r', D, t)
    b = FastExp(a,2^t*f,n)-1;
    D = gcd(b,n);
    t = t-1;
    fprintf('Compute b = a^(2^t*f)-1 = %d, D = gcd(b,n) = %d, and update t = t - 1 = %d.\r', b,D,t)   
end
if  ~ismember(D,[1 n])
    fprintf('A factor of %d is found to be %d.\r', n, D)
else
    fprintf('Algorithm did not succeed with random seed a = %d.\r', a)
end

