function x = ChineseRemainderSoln(bVec,nVec)
%x = ChineseRemainderSoln(bVec,nVec)
% Inputs: bVec, nVec =  two same-sized vectors of integers, where
% n(i)'s are pairwise relatively prime positive integers.
% Output:  x = the unique integer solution mod(product(nVec)) of the system
% of congruencies:
%   x= a(1) mod n(1)
%   x= a(2) mod n(2)
%   ...
%   x= a(k) mod n(k)
% as determined by the algorithm in the existence proof of the Chinese
% remainder theorem.  
k=length(bVec);
N=prod(nVec);
x=0; %initialize x
for i=1:k
   x=x+bVec(i)*(N/nVec(i))*ModInv(N/nVec(i),nVec(i));
   x=mod(x,N);
end  
