function OutVec = EuclidAlgExtShow(a,b)
%  [d x y] = EuclidAlgExt(a,b)
%This program performs the extendedEuclidean algorithm, with all intermediate
%steps being shown. It inputs two positive
%integers a >= b, and outputs their greatest common divisor 
%d = gcd(a,b) along with two integers x and y such that d = ax + by.
aa = max(a,b); bb = min(a,b);
U = [aa 1 0]; V = [bb 0 1];
fprintf('Initial Vectors:  U = [%d, %d, %d], V = [%d, %d, %d].\r', U, V)
while V(1) > 0
    fprintf('Since V(1) = %d is positive, we update the vectors:\r', V(1))
    W = U - floor(U(1)/V(1))*V;
    U = V; V = W;
    fprintf('W = U - floor(U(1)/V(1))*V = [%d, %d, %d], U = V = [%d, %d, %d], V = W = [%d, %d, %d].\r', W,U,V)
end
fprintf('Since V(1) = 0, the algorithm terminates.\r')
d = U(1); x = U(2); y = U(3);
OutVec = [d x y];
