%Script Files for Section 9.2:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%EFR 9.11:
Edges = [1 2 1;
    1 4 2;
    1 5 3;
    2 5 4;
    2 6 5;
    3 6 6;
    3 7 7;
    4 5 8;
    4 8 9;
    5 6 10;
    5 8 11;
    5 9 12;
    6 7 13;
    6 9 14;
    6 10 15;
    8 9 16;
    9 10 17]
Wgts = [6 12 8 4 3 6 2 5 3 2 4 4 5 2 3 2 10]
startV = 1;
n = 10;
[ParentList DiscoveryList DistanceList] = Dijkstra(Edges, Wgts, startV, n)
%OUTPUT:
%ParentList =
%     1     0
%     2     1
%     3     6
%     4     1
%     5     1
%     6     2
%     7     6
%     8     5
%     9     6
%    10     6
%DiscoveryList =
%     1     2     5     6     9     4     8    10     7     3
%DistanceList =
%     0     6     8     9    11    12    12    12    14    15
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%EFR 9.12:
Edges = [1 2 1;
    1 4 2;
    3 1 3;
    3 6 4;
    4 2 5;
    4 3 6;
    4 5 7;
    4 7 8;
    5 2 9;
    5 7 10;
    5 8 11;
    6 4 12;
    7 6 13;
    7 8 14]
Wgts = [12 3 6 3 4 5 2 4 6 2 3 4 2 10]
startV = 1;
n = 8;
[ParentList DiscoveryList DistanceList] = DijkstraDigraph(Edges, Wgts, startV, n)
%OUTPUT:
%ParentList =
%     1     0
%     2     4
%     3     4
%     4     1
%     5     4
%     6     7
%     7     4
%     8     5
%DiscoveryList =
%     1     4     5     2     7     3     8     6
%DistanceList =
%     0     3     5     7     7     8     8     9


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%EFR 9.20:
Edges = [1 2;
    1 4;
    2 3;
    3 4;
    3 6;
    4 5;
    5 6];
Wgts = [6  6  4  4  6  4  4];
Flow = [4  0  4  4  0  4  4];
[maxFlow, Flow]= FordFulkerson(Edges,Wgts,Flow)
%OUTPUT:
%maxFlow =
%     8
%Flow =
%     4     4     4     0     4     4     4
[maxFlow, Flow]= FordFulkersonShow(Edges,Wgts,Flow)
%OUTPUT:
%After iteration #1, we have:
%Labels:
%Label =
%     0     1   Inf
%     1     1     2
%     4    -1     4
%     1     1     6
%     0     0     0
%     3     1     4
%Flow:
%Flow =
%     4     4     4     0     4     4     4
%Value of flow:
%maxFlow =
%     8
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%
%After iteration #2, we have:
%Labels:
%Label =
%     0     1   Inf
%     1     1     2
%     0     0     0
%     1     1     2
%Flow:
%Flow =
%     4     4     4     0     4     4     4
%Value of flow:
%maxFlow =
%     8
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%
%maxFlow =
%     8
%Flow =
%     4     4     4     0     4     4     4

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%EFR 9.21:
Edges = [1 2;
    1 4;
    1 6;
    2 3;
    4 5;
    6 4;
    6 7;
    3 4;
    3 8;
    5 7;
    5 8;
    7 8];
Wgts = [15 8 16 10 10 20 12 5 8 13 11 10];
[maxFlow, Flow]= FordFulkersonShow(Edges,Wgts)
%OUTPUT:
%After iteration #1, we have:
%Labels:
%Label =
%     0     1   Inf
%     1     1    15
%     2     1    10
%     1     1     8
%     4     1     8
%     1     1    16
%     6     1    12
%     3     1     8
%Flow:
%Flow =
%     8     0     0     8     0     0     0     0     8     0     0     0
%Value of flow:
%maxFlow =
%     8
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%
%After iteration #2, we have:
%Labels:
%Label =
%     0     1   Inf
%     1     1     7
%     2     1     2
%     1     1     8
%     4     1     8
%     1     1    16
%     6     1    12
%     5     1     8
%Flow:
%Flow =
%     8     8     0     8     8     0     0     0     8     0     8     0
%Value of flow:
%maxFlow =
%    16
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%
%After iteration #3, we have:
%Labels:
%Label =
%     0     1   Inf
%     1     1     7
%     2     1     2
%     6     1    16
%     4     1     2
%     1     1    16
%     6     1    12
%     7     1    10
%Flow:
%Flow =
%     8     8    10     8     8     0    10     0     8     0     8    10
%Value of flow:
%maxFlow =
%    26
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%
%After iteration #4, we have:
%Labels:
%Label =
%     0     1   Inf
%     1     1     7
%     2     1     2
%     6     1     6
%     4     1     2
%     1     1     6
%     6     1     2
%     5     1     2
%Flow:
%Flow =
%     8     8    12     8    10     2    10     0     8     0    10    10
%Value of flow:
%maxFlow =
%    28
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%
%After iteration #5, we have:
%Labels:
%Label =
%     0     1   Inf
%     1     1     7
%     2     1     2
%     6     1     4
%     0     0     0
%     1     1     4
%     6     1     2
%Flow:
%Flow =
%     8     8    12     8    10     2    10     0     8     0    10    10
%Value of flow:
%maxFlow =
%    28
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%
%maxFlow =
%    28
%Flow =
%     8     8    12     8    10     2    10     0     8     0    10    10

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%EFR 9.24:
Edges = [1 2;
    1 3; 
    1 4;
    1 5;
    1 6;
    2 10;
    3 8;
    3 10;
    4 11;
    5 7;
    6 9;
    6 11;
    7 12;
    8 12;
    9 12;
    10 12;
    11 12];
[rE cE] = size(Edges);
Wgts = ones(1,rE);
[maxFlow, Flow]= FordFulkersonShow(Edges,Wgts)
%OUTPUT:
%maxFlow =
%     5
%Flow =
%  Columns 1 through 16
%     1     1     1     1     1     1     1     0     1     1     1     0     1     1     1     1
%  Column 17
%     1


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Fig 9.64a Flow:
Edges = [1 2;
    1 3;
    1 4;
    2 3;
    2 4;
    2 5;
    3 4; 
    3 5;
    4 5];
Wgts = [14 6 10 10 8 6 10 10 20];
[maxFlow, Flow]= FordFulkersonShow(Edges,Wgts)
%7a:
Flow = zeros(size(Wgts)); Flow([3 9]) = 10;
[maxFlow, Flow]= FordFulkersonShow(Edges,Wgts,Flow)
%7b:
Flow = zeros(size(Wgts)); Flow([2 8]) = 4;
[maxFlow, Flow]= FordFulkersonShow(Edges,Wgts,Flow)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Fig 9.64b Flow:
Edges = [1 2;
    1 4;
    2 3;
    2 4;
    2 6;
    3 5;
    3 7;
    4 5;
    4 6;
    5 6;
    5 7;
    6 3;
    6 7];
Wgts = [10 20 6 6 6 7 10 18 8 6 10 6 6];
[maxFlow, Flow]= FordFulkersonShow(Edges,Wgts)
%7d:
Flow = zeros(size(Wgts)); Flow(1) = 10; Flow([3 5 7 13]) = 5;
[maxFlow, Flow]= FordFulkersonShow(Edges,Wgts,Flow)
%7e:
Flow = zeros(size(Wgts));  Flow([2 9  13]) = 5;
[maxFlow, Flow]= FordFulkersonShow(Edges,Wgts,Flow)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Fig 9.66a Flow Network:
IndEdges = [1 1 2 10;
    2  1 3 9;
    3  1 6 6;
    4  1 8 20;
    5  2 4 2;
    6  2 9 10;
    7  3 2 3;
    8  3 4 8;
    9  3 5 6;
    10 3 6 8;
    11 4 7 7;
    12 4 9 18;
    13 5 4 9;
    14 5 9 6;
    15 6 5 8;
    16 6 7 6;
    17 6 8 6;
    18 7 5 5;
    19 7 9 10;
    20 8 5 8;
    21 8 7 12];
Edges = IndEdges(:,2:3);
Wgts = IndEdges(:,4)';
%9a:
Flow = zeros(size(Wgts));  Flow([1 6]) = 10;
[maxFlow, Flow]= FordFulkersonShow(Edges,Wgts,Flow)
%9b:
Flow = zeros(size(Wgts));  Flow([4 20 14]) = 5;
[maxFlow, Flow]= FordFulkersonShow(Edges,Wgts,Flow)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Fig 9.66b Flow Network:
IndEdges = [1 1 2 4;
    2  1 4 4;
    3  1 5 7;
    4  1 7 4;
    5  1 8 3;
    6  2 3 2;
    7  2 5 4
    8  2 10 4;
    9  3 6 2;
    10 3 10 4;
    11 4 2 4;
    12 4 3 4;
    13 5 4 3;
    14 5 6 4;
    15 5 7 4;
    16 5 8 4;
    17 6 4 4;
    18 6 10 5;
    19 7 6 1;
    20 7 9 5;
    21 8 7 4;
    22 8 9 3;
    23 8 10 4;
    24 9 6 3;
    25 9 10 4];
Edges = IndEdges(:,2:3);
Wgts = IndEdges(:,4)';
%9d:
Flow = zeros(size(Wgts));  Flow([1 8]) = 4;
[maxFlow, Flow]= FordFulkersonShow(Edges,Wgts,Flow)
%9e:
Flow = zeros(size(Wgts));  Flow([2 12 10]) = 3;
[maxFlow, Flow]= FordFulkersonShow(Edges,Wgts,Flow)
    

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Exercise 9.2.15:  Machine Shop Scheduling:
IndEdges = [1 1 2 3;
    2  1 3 2;
    3  1 4 3;
    4  1 5 2;
    5  1 6 5;
    6  2 7 1;
    7  2 8 1;
    8  2 9 2;
    9  3 8 1;
    10 3 9 2;
    11 3 10 1;
    12 4 10 1;
    13 4 11 1;
    15 4 12 2;
    16 5 7 1;
    17 5 8 1;
    18 5 9 2;
    19 5 10 1;
    20 5 11 1;
    21 6 9 2;
    22 6 10 1;
    23 6 11 1;
    24 6 12 2;
    25 7 13 2;
    26 8 13 2;
    27 9 13 4;
    28 10 13 2;
    29 11 13 2;
    30 12 13 4];
Edges = IndEdges(:,2:3);
Wgts = IndEdges(:,4)';
[maxFlow, Flow]= FordFulkersonShow(Edges,Wgts)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Exercise 9.2.17:  Disjoint Path Counting:
IndEdges = [1 1 2;
    2  1 3;
    3  1 5;
    4  1 7;
    5  1 8;
    6  1 9;
    7  2 3;
    8  3 2;
    9  2 6;
    10 6 2;
    11 2 9;
    12 9 2;
    13 3 5;
    14 5 3;
    15 3 6;
    16 6 3;
    17 4 6;
    18 6 4;
    19 4 8;
    20 8 4;
    21 5 6;
    22 6 5;
    23 5 8;
    24 8 5;
    25 6 7;
    26 7 6;
    27 6 8;
    28 8 6;
    29 7 8;
    30 8 7;
    31 7 9;
    32 9 7;
    33 7 10;
    34 10 7;
    35 9 10;
    36 10 9;
    37 3 11;
    38 4 11;
    39 6 11;
    40 8 11;
    41 9 11;
    42 10 11];
    
Edges = IndEdges(:,2:3);
[rE cE] = size(Edges);
Wgts = ones(1,rE);
[maxFlow, Flow]= FordFulkersonShow(Edges,Wgts)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Exercise 21:  Marriage Problem:
IndEdges = [1 1 2;
    2  1 3;
    3  1 4;
    4  1 5; 
    5  1 6;
    6  1 7;
    7  2 8;
    8  2 11;
    9  3 11;
    10 3 13;
    11 4 12;
    12 5 8;
    13 5 13;
    14 6 9;
    15 6 12;
    16 7 8;
    17 7 10;
    18 7 13;
    19 8 14;
    20 9 14;
    21 10 14;
    22 11 14;
    23 12 14;
    24 13 14];
Edges = IndEdges(:,2:3);
[rE cE] = size(Edges);
Wgts = ones(1,rE);
[maxFlow, Flow]= FordFulkersonShow(Edges,Wgts)

    
    